'**********************************************************************
'* Name: AK Font NonVesa Print
'* Entwickler: ZaPPa (DC-Ware Entertainment)
'* Beschreibnf: Ermglicht dem Benutzer das Verwenden von AK-Fonts
'               im SCREEN 7, 8, 9, 10, 12
'* Datum: 28.9.2004
'**********************************************************************
'Declares
 DECLARE FUNCTION Byte2BM$ (Byte$)   'Byte in Bitmaske wandeln
                                     'Spart viel Speicher
 DECLARE SUB InitFF (FFile$)         'Schriftart laden!!!
 DECLARE SUB ZPrint (X%, Y%, Text$, FCol%) 'Die Zeichenroutine

'DataFields
 DIM SHARED BitMask(255, 15) AS STRING * 1 'Die Bitmaskenbytes ;)
 DIM SHARED PutData%(68)                   'Das PUT-Datenfeld
 COMMON SHARED FontB%, FontH%              'Schriftgre


 InitFF "Default.ARL"       'Standardfont wird geladen
                            ' MUSS SEIN!!!
 SCREEN 12
 CLS

 FOR L% = 1 TO 15
  ZPrint 20 + L% * 10, 20 + L% * 20, "DC-Ware has done it again!", L%
 NEXT

'ZPrint Parameter Beschreibung:
'
'   X%    <== X-Position in Pixeln
'   Y%    <== Y-Position in Pixeln
'   Text$ <== Der anzuzeigende Text
'   FCol% <== Die Schriftfarbe

'  FCol% Werte Sind:
'  0 = Schwarz
'  1 = Blau
'  2 = Grau
'  3 = Blau    ( Hell )
'  4 = Rot
'  5 = Violett
'  6 = Rot     ( Hell )
'  7 = Violett ( Hell )
'  8 = Grn
'  9 = Cyan
'  10= Grn    ( Hell )
'  11= Cyan    ( Hell )
'  12= Braun
'  13= Grau    ( Hell )
'  14= Gelb
'  15= Wei

FUNCTION Byte2BM$ (Byte$) 'Standardroutine zum Umwandeln von
zahl% = ASC(Byte$)        'Dezimalzahlen in Binrzahlen
Z% = 2 ^ 7
FOR X% = 0 TO 7
  IF zahl% - Z% >= 0 THEN
    Bin$ = Bin$ + "1"
    zahl% = zahl% - Z%
  ELSE
    Bin$ = Bin$ + "0"
  END IF
  Z% = Z% / 2
NEXT
Byte2BM$ = Bin$
END FUNCTION

SUB InitFF (FFile$)   'Eigens entwickelte Lade-Funktion
                      'Entspricht ngefhr der AK-Lib

IF UCASE$(RIGHT$(FFile$, 4)) <> ".ARL" THEN FFile$ = FFile$ + ".arl"

OPEN FFile$ FOR BINARY AS #1
 IF LOF(1) = 0 THEN CLOSE : KILL FFile$: LOCATE 1, 1: PRINT "Datei nicht gefunden!": SLEEP: GOTO abort
 IF LOF(1) = 4098 OR LOF(1) = 3586 OR LOF(1) = 2050 THEN
  H$ = "  "
  FontFormat$ = "AKO"
 END IF
 GET #1, , H$
 FontSize$ = H$
 FontB% = ASC(MID$(FontSize$, 1, 1))
 FontH% = ASC(MID$(FontSize$, 2, 1))
 SByte$ = " "
 FOR L = 0 TO 255
  FOR Q = 0 TO FontH% - 1
   GET #1, , SByte$
   BitMask(L, Q) = SByte$
  NEXT
 NEXT
CLOSE
FontFile$ = LEFT$(FFile$, LEN(FFile$) - 4)
abort:

END SUB

SUB ZPrint (X%, Y%, Text$, FCol%)  ', BGCol%)


'Das Eigentliche Geheimnis von GET/PUT DATEN


Col$ = RIGHT$(Byte2BM$(CHR$(FCol%)), 4) 'Hier wird zuerst eine Bitmaske
Col$ = Col$ + Col$                      'Fr die Farbe erstellt und
                                        'verdoppelt

PutData%(0) = FontB% + 1               'Gre zuweisen
PutData%(1) = FontH% + 1

FOR S = 1 TO LEN(Text$)

 FOR L = 0 TO FontH% - 1
 
  BM% = ASC(BitMask(ASC(MID$(Text$, S, 1)), L)) 'Zeile fr Zeile das Zeichen
                                                'in eine dezimalzahl wandeln
 
  FOR Q = L * 4 + 2 TO (L + 1) * 4 + 2
   PutData%(Q) = BM% * VAL(MID$(Col$, (Q - L * 4 + 2), 1))
  NEXT                                  'und dann mit dem entsprechendem
                                        'farbbit multiplizieren!
 
 NEXT
 
 XO% = X% + (S * 8)
 PUT (XO%, Y%), PutData%, PSET

NEXT S


'Fragt mich nich wie ich drauf gekommen ober wie es genau funktioniert
'Ich habe einfach jeden geistesblitz ausprobiert und siehe da:
' nach drei tagen funzt es endlich!!!

END SUB




